<?php

namespace rdyescapiacontent\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCalendarAvailType ArrayType
 * @subpackage Arrays
 */
class ArrayOfCalendarAvailType extends AbstractStructArrayBase
{
    /**
     * The CalendarAvail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\CalendarAvailType[]
     */
    public $CalendarAvail;
    /**
     * Constructor method for ArrayOfCalendarAvailType
     * @uses ArrayOfCalendarAvailType::setCalendarAvail()
     * @param \rdyescapiacontent\StructType\CalendarAvailType[] $calendarAvail
     */
    public function __construct(array $calendarAvail = array())
    {
        $this
            ->setCalendarAvail($calendarAvail);
    }
    /**
     * Get CalendarAvail value
     * @return \rdyescapiacontent\StructType\CalendarAvailType[]|null
     */
    public function getCalendarAvail()
    {
        return $this->CalendarAvail;
    }
    /**
     * This method is responsible for validating the values passed to the setCalendarAvail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCalendarAvail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCalendarAvailForArrayConstraintsFromSetCalendarAvail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCalendarAvailTypeCalendarAvailItem) {
            // validation for constraint: itemType
            if (!$arrayOfCalendarAvailTypeCalendarAvailItem instanceof \rdyescapiacontent\StructType\CalendarAvailType) {
                $invalidValues[] = is_object($arrayOfCalendarAvailTypeCalendarAvailItem) ? get_class($arrayOfCalendarAvailTypeCalendarAvailItem) : sprintf('%s(%s)', gettype($arrayOfCalendarAvailTypeCalendarAvailItem), var_export($arrayOfCalendarAvailTypeCalendarAvailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CalendarAvail property can only contain items of type \rdyescapiacontent\StructType\CalendarAvailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CalendarAvail value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\CalendarAvailType[] $calendarAvail
     * @return \rdyescapiacontent\ArrayType\ArrayOfCalendarAvailType
     */
    public function setCalendarAvail(array $calendarAvail = array())
    {
        // validation for constraint: array
        if ('' !== ($calendarAvailArrayErrorMessage = self::validateCalendarAvailForArrayConstraintsFromSetCalendarAvail($calendarAvail))) {
            throw new \InvalidArgumentException($calendarAvailArrayErrorMessage, __LINE__);
        }
        $this->CalendarAvail = $calendarAvail;
        return $this;
    }
    /**
     * Add item to CalendarAvail value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\CalendarAvailType $item
     * @return \rdyescapiacontent\ArrayType\ArrayOfCalendarAvailType
     */
    public function addToCalendarAvail(\rdyescapiacontent\StructType\CalendarAvailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\CalendarAvailType) {
            throw new \InvalidArgumentException(sprintf('The CalendarAvail property can only contain items of type \rdyescapiacontent\StructType\CalendarAvailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CalendarAvail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \rdyescapiacontent\StructType\CalendarAvailType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \rdyescapiacontent\StructType\CalendarAvailType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \rdyescapiacontent\StructType\CalendarAvailType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \rdyescapiacontent\StructType\CalendarAvailType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \rdyescapiacontent\StructType\CalendarAvailType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CalendarAvail
     */
    public function getAttributeName()
    {
        return 'CalendarAvail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\ArrayType\ArrayOfCalendarAvailType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
