<?php

namespace rdyescapiacontent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EVRN_CategoryCodesType StructType
 * @subpackage Structs
 */
class EVRN_CategoryCodesType extends AbstractStructBase
{
    /**
     * The LocationCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\LocationCategory[]
     */
    public $LocationCategory;
    /**
     * The UnitCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\UnitCategory[]
     */
    public $UnitCategory;
    /**
     * The RoomInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\RoomInfo[]
     */
    public $RoomInfo;
    /**
     * The BedInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\BedInfo[]
     */
    public $BedInfo;
    /**
     * The PropertyManagerCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\PropertyManagerCategory[]
     */
    public $PropertyManagerCategory;
    /**
     * The CustomCategoryGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\CustomCategoryGroupType[]
     */
    public $CustomCategoryGroup;
    /**
     * Constructor method for EVRN_CategoryCodesType
     * @uses EVRN_CategoryCodesType::setLocationCategory()
     * @uses EVRN_CategoryCodesType::setUnitCategory()
     * @uses EVRN_CategoryCodesType::setRoomInfo()
     * @uses EVRN_CategoryCodesType::setBedInfo()
     * @uses EVRN_CategoryCodesType::setPropertyManagerCategory()
     * @uses EVRN_CategoryCodesType::setCustomCategoryGroup()
     * @param \rdyescapiacontent\StructType\LocationCategory[] $locationCategory
     * @param \rdyescapiacontent\StructType\UnitCategory[] $unitCategory
     * @param \rdyescapiacontent\StructType\RoomInfo[] $roomInfo
     * @param \rdyescapiacontent\StructType\BedInfo[] $bedInfo
     * @param \rdyescapiacontent\StructType\PropertyManagerCategory[] $propertyManagerCategory
     * @param \rdyescapiacontent\StructType\CustomCategoryGroupType[] $customCategoryGroup
     */
    public function __construct(array $locationCategory = array(), array $unitCategory = array(), array $roomInfo = array(), array $bedInfo = array(), array $propertyManagerCategory = array(), array $customCategoryGroup = array())
    {
        $this
            ->setLocationCategory($locationCategory)
            ->setUnitCategory($unitCategory)
            ->setRoomInfo($roomInfo)
            ->setBedInfo($bedInfo)
            ->setPropertyManagerCategory($propertyManagerCategory)
            ->setCustomCategoryGroup($customCategoryGroup);
    }
    /**
     * Get LocationCategory value
     * @return \rdyescapiacontent\StructType\LocationCategory[]|null
     */
    public function getLocationCategory()
    {
        return $this->LocationCategory;
    }
    /**
     * This method is responsible for validating the values passed to the setLocationCategory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLocationCategory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLocationCategoryForArrayConstraintsFromSetLocationCategory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eVRN_CategoryCodesTypeLocationCategoryItem) {
            // validation for constraint: itemType
            if (!$eVRN_CategoryCodesTypeLocationCategoryItem instanceof \rdyescapiacontent\StructType\LocationCategory) {
                $invalidValues[] = is_object($eVRN_CategoryCodesTypeLocationCategoryItem) ? get_class($eVRN_CategoryCodesTypeLocationCategoryItem) : sprintf('%s(%s)', gettype($eVRN_CategoryCodesTypeLocationCategoryItem), var_export($eVRN_CategoryCodesTypeLocationCategoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LocationCategory property can only contain items of type \rdyescapiacontent\StructType\LocationCategory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LocationCategory value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\LocationCategory[] $locationCategory
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function setLocationCategory(array $locationCategory = array())
    {
        // validation for constraint: array
        if ('' !== ($locationCategoryArrayErrorMessage = self::validateLocationCategoryForArrayConstraintsFromSetLocationCategory($locationCategory))) {
            throw new \InvalidArgumentException($locationCategoryArrayErrorMessage, __LINE__);
        }
        $this->LocationCategory = $locationCategory;
        return $this;
    }
    /**
     * Add item to LocationCategory value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\LocationCategory $item
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function addToLocationCategory(\rdyescapiacontent\StructType\LocationCategory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\LocationCategory) {
            throw new \InvalidArgumentException(sprintf('The LocationCategory property can only contain items of type \rdyescapiacontent\StructType\LocationCategory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LocationCategory[] = $item;
        return $this;
    }
    /**
     * Get UnitCategory value
     * @return \rdyescapiacontent\StructType\UnitCategory[]|null
     */
    public function getUnitCategory()
    {
        return $this->UnitCategory;
    }
    /**
     * This method is responsible for validating the values passed to the setUnitCategory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUnitCategory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUnitCategoryForArrayConstraintsFromSetUnitCategory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eVRN_CategoryCodesTypeUnitCategoryItem) {
            // validation for constraint: itemType
            if (!$eVRN_CategoryCodesTypeUnitCategoryItem instanceof \rdyescapiacontent\StructType\UnitCategory) {
                $invalidValues[] = is_object($eVRN_CategoryCodesTypeUnitCategoryItem) ? get_class($eVRN_CategoryCodesTypeUnitCategoryItem) : sprintf('%s(%s)', gettype($eVRN_CategoryCodesTypeUnitCategoryItem), var_export($eVRN_CategoryCodesTypeUnitCategoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UnitCategory property can only contain items of type \rdyescapiacontent\StructType\UnitCategory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UnitCategory value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\UnitCategory[] $unitCategory
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function setUnitCategory(array $unitCategory = array())
    {
        // validation for constraint: array
        if ('' !== ($unitCategoryArrayErrorMessage = self::validateUnitCategoryForArrayConstraintsFromSetUnitCategory($unitCategory))) {
            throw new \InvalidArgumentException($unitCategoryArrayErrorMessage, __LINE__);
        }
        $this->UnitCategory = $unitCategory;
        return $this;
    }
    /**
     * Add item to UnitCategory value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\UnitCategory $item
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function addToUnitCategory(\rdyescapiacontent\StructType\UnitCategory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\UnitCategory) {
            throw new \InvalidArgumentException(sprintf('The UnitCategory property can only contain items of type \rdyescapiacontent\StructType\UnitCategory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UnitCategory[] = $item;
        return $this;
    }
    /**
     * Get RoomInfo value
     * @return \rdyescapiacontent\StructType\RoomInfo[]|null
     */
    public function getRoomInfo()
    {
        return $this->RoomInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomInfoForArrayConstraintsFromSetRoomInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eVRN_CategoryCodesTypeRoomInfoItem) {
            // validation for constraint: itemType
            if (!$eVRN_CategoryCodesTypeRoomInfoItem instanceof \rdyescapiacontent\StructType\RoomInfo) {
                $invalidValues[] = is_object($eVRN_CategoryCodesTypeRoomInfoItem) ? get_class($eVRN_CategoryCodesTypeRoomInfoItem) : sprintf('%s(%s)', gettype($eVRN_CategoryCodesTypeRoomInfoItem), var_export($eVRN_CategoryCodesTypeRoomInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomInfo property can only contain items of type \rdyescapiacontent\StructType\RoomInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomInfo value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\RoomInfo[] $roomInfo
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function setRoomInfo(array $roomInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($roomInfoArrayErrorMessage = self::validateRoomInfoForArrayConstraintsFromSetRoomInfo($roomInfo))) {
            throw new \InvalidArgumentException($roomInfoArrayErrorMessage, __LINE__);
        }
        $this->RoomInfo = $roomInfo;
        return $this;
    }
    /**
     * Add item to RoomInfo value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\RoomInfo $item
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function addToRoomInfo(\rdyescapiacontent\StructType\RoomInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\RoomInfo) {
            throw new \InvalidArgumentException(sprintf('The RoomInfo property can only contain items of type \rdyescapiacontent\StructType\RoomInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomInfo[] = $item;
        return $this;
    }
    /**
     * Get BedInfo value
     * @return \rdyescapiacontent\StructType\BedInfo[]|null
     */
    public function getBedInfo()
    {
        return $this->BedInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setBedInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBedInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBedInfoForArrayConstraintsFromSetBedInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eVRN_CategoryCodesTypeBedInfoItem) {
            // validation for constraint: itemType
            if (!$eVRN_CategoryCodesTypeBedInfoItem instanceof \rdyescapiacontent\StructType\BedInfo) {
                $invalidValues[] = is_object($eVRN_CategoryCodesTypeBedInfoItem) ? get_class($eVRN_CategoryCodesTypeBedInfoItem) : sprintf('%s(%s)', gettype($eVRN_CategoryCodesTypeBedInfoItem), var_export($eVRN_CategoryCodesTypeBedInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BedInfo property can only contain items of type \rdyescapiacontent\StructType\BedInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BedInfo value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\BedInfo[] $bedInfo
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function setBedInfo(array $bedInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($bedInfoArrayErrorMessage = self::validateBedInfoForArrayConstraintsFromSetBedInfo($bedInfo))) {
            throw new \InvalidArgumentException($bedInfoArrayErrorMessage, __LINE__);
        }
        $this->BedInfo = $bedInfo;
        return $this;
    }
    /**
     * Add item to BedInfo value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\BedInfo $item
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function addToBedInfo(\rdyescapiacontent\StructType\BedInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\BedInfo) {
            throw new \InvalidArgumentException(sprintf('The BedInfo property can only contain items of type \rdyescapiacontent\StructType\BedInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BedInfo[] = $item;
        return $this;
    }
    /**
     * Get PropertyManagerCategory value
     * @return \rdyescapiacontent\StructType\PropertyManagerCategory[]|null
     */
    public function getPropertyManagerCategory()
    {
        return $this->PropertyManagerCategory;
    }
    /**
     * This method is responsible for validating the values passed to the setPropertyManagerCategory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPropertyManagerCategory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePropertyManagerCategoryForArrayConstraintsFromSetPropertyManagerCategory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eVRN_CategoryCodesTypePropertyManagerCategoryItem) {
            // validation for constraint: itemType
            if (!$eVRN_CategoryCodesTypePropertyManagerCategoryItem instanceof \rdyescapiacontent\StructType\PropertyManagerCategory) {
                $invalidValues[] = is_object($eVRN_CategoryCodesTypePropertyManagerCategoryItem) ? get_class($eVRN_CategoryCodesTypePropertyManagerCategoryItem) : sprintf('%s(%s)', gettype($eVRN_CategoryCodesTypePropertyManagerCategoryItem), var_export($eVRN_CategoryCodesTypePropertyManagerCategoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PropertyManagerCategory property can only contain items of type \rdyescapiacontent\StructType\PropertyManagerCategory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PropertyManagerCategory value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\PropertyManagerCategory[] $propertyManagerCategory
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function setPropertyManagerCategory(array $propertyManagerCategory = array())
    {
        // validation for constraint: array
        if ('' !== ($propertyManagerCategoryArrayErrorMessage = self::validatePropertyManagerCategoryForArrayConstraintsFromSetPropertyManagerCategory($propertyManagerCategory))) {
            throw new \InvalidArgumentException($propertyManagerCategoryArrayErrorMessage, __LINE__);
        }
        $this->PropertyManagerCategory = $propertyManagerCategory;
        return $this;
    }
    /**
     * Add item to PropertyManagerCategory value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\PropertyManagerCategory $item
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function addToPropertyManagerCategory(\rdyescapiacontent\StructType\PropertyManagerCategory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\PropertyManagerCategory) {
            throw new \InvalidArgumentException(sprintf('The PropertyManagerCategory property can only contain items of type \rdyescapiacontent\StructType\PropertyManagerCategory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PropertyManagerCategory[] = $item;
        return $this;
    }
    /**
     * Get CustomCategoryGroup value
     * @return \rdyescapiacontent\StructType\CustomCategoryGroupType[]|null
     */
    public function getCustomCategoryGroup()
    {
        return $this->CustomCategoryGroup;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomCategoryGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomCategoryGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomCategoryGroupForArrayConstraintsFromSetCustomCategoryGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eVRN_CategoryCodesTypeCustomCategoryGroupItem) {
            // validation for constraint: itemType
            if (!$eVRN_CategoryCodesTypeCustomCategoryGroupItem instanceof \rdyescapiacontent\StructType\CustomCategoryGroupType) {
                $invalidValues[] = is_object($eVRN_CategoryCodesTypeCustomCategoryGroupItem) ? get_class($eVRN_CategoryCodesTypeCustomCategoryGroupItem) : sprintf('%s(%s)', gettype($eVRN_CategoryCodesTypeCustomCategoryGroupItem), var_export($eVRN_CategoryCodesTypeCustomCategoryGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomCategoryGroup property can only contain items of type \rdyescapiacontent\StructType\CustomCategoryGroupType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomCategoryGroup value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\CustomCategoryGroupType[] $customCategoryGroup
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function setCustomCategoryGroup(array $customCategoryGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($customCategoryGroupArrayErrorMessage = self::validateCustomCategoryGroupForArrayConstraintsFromSetCustomCategoryGroup($customCategoryGroup))) {
            throw new \InvalidArgumentException($customCategoryGroupArrayErrorMessage, __LINE__);
        }
        $this->CustomCategoryGroup = $customCategoryGroup;
        return $this;
    }
    /**
     * Add item to CustomCategoryGroup value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\CustomCategoryGroupType $item
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public function addToCustomCategoryGroup(\rdyescapiacontent\StructType\CustomCategoryGroupType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\CustomCategoryGroupType) {
            throw new \InvalidArgumentException(sprintf('The CustomCategoryGroup property can only contain items of type \rdyescapiacontent\StructType\CustomCategoryGroupType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomCategoryGroup[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\StructType\EVRN_CategoryCodesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
