<?php

namespace rdyescapiacontent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EVRN_UnitCalendarAvailRS StructType
 * @subpackage Structs
 */
class EVRN_UnitCalendarAvailRS extends EVRN_BaseRSType
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - choice: Success | UnitCalendarAvailSegments | Errors | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\SuccessType
     */
    public $Success;
    /**
     * The UnitCalendarAvailSegments
     * Meta information extracted from the WSDL
     * - choice: Success | UnitCalendarAvailSegments | Errors | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\UnitCalendarAvailSegments
     */
    public $UnitCalendarAvailSegments;
    /**
     * The Errors
     * Meta information extracted from the WSDL
     * - choice: Success | UnitCalendarAvailSegments | Errors | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\ErrorsType
     */
    public $Errors;
    /**
     * The Warnings
     * Meta information extracted from the WSDL
     * - choice: Success | UnitCalendarAvailSegments | Errors | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\WarningsType
     */
    public $Warnings;
    /**
     * Constructor method for EVRN_UnitCalendarAvailRS
     * @uses EVRN_UnitCalendarAvailRS::setSuccess()
     * @uses EVRN_UnitCalendarAvailRS::setUnitCalendarAvailSegments()
     * @uses EVRN_UnitCalendarAvailRS::setErrors()
     * @uses EVRN_UnitCalendarAvailRS::setWarnings()
     * @param \rdyescapiacontent\StructType\SuccessType $success
     * @param \rdyescapiacontent\StructType\UnitCalendarAvailSegments $unitCalendarAvailSegments
     * @param \rdyescapiacontent\StructType\ErrorsType $errors
     * @param \rdyescapiacontent\StructType\WarningsType $warnings
     */
    public function __construct(\rdyescapiacontent\StructType\SuccessType $success = null, \rdyescapiacontent\StructType\UnitCalendarAvailSegments $unitCalendarAvailSegments = null, \rdyescapiacontent\StructType\ErrorsType $errors = null, \rdyescapiacontent\StructType\WarningsType $warnings = null)
    {
        $this
            ->setSuccess($success)
            ->setUnitCalendarAvailSegments($unitCalendarAvailSegments)
            ->setErrors($errors)
            ->setWarnings($warnings);
    }
    /**
     * Get Success value
     * @return \rdyescapiacontent\StructType\SuccessType|null
     */
    public function getSuccess()
    {
        return isset($this->Success) ? $this->Success : null;
    }
    /**
     * This method is responsible for validating the value passed to the setSuccess method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSuccess method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateSuccessForChoiceConstraintsFromSetSuccess($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'UnitCalendarAvailSegments',
            'Errors',
            'Warnings',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Success can\'t be set as the property %s is already set. Only one property must be set among these properties: Success, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Success value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\SuccessType $success
     * @return \rdyescapiacontent\StructType\EVRN_UnitCalendarAvailRS
     */
    public function setSuccess(\rdyescapiacontent\StructType\SuccessType $success = null)
    {
        // validation for constraint: choice(Success, UnitCalendarAvailSegments, Errors, Warnings)
        if ('' !== ($successChoiceErrorMessage = self::validateSuccessForChoiceConstraintsFromSetSuccess($success))) {
            throw new \InvalidArgumentException($successChoiceErrorMessage, __LINE__);
        }
        if (is_null($success) || (is_array($success) && empty($success))) {
            unset($this->Success);
        } else {
            $this->Success = $success;
        }
        return $this;
    }
    /**
     * Get UnitCalendarAvailSegments value
     * @return \rdyescapiacontent\StructType\UnitCalendarAvailSegments|null
     */
    public function getUnitCalendarAvailSegments()
    {
        return isset($this->UnitCalendarAvailSegments) ? $this->UnitCalendarAvailSegments : null;
    }
    /**
     * This method is responsible for validating the value passed to the setUnitCalendarAvailSegments method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUnitCalendarAvailSegments method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateUnitCalendarAvailSegmentsForChoiceConstraintsFromSetUnitCalendarAvailSegments($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Success',
            'Errors',
            'Warnings',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property UnitCalendarAvailSegments can\'t be set as the property %s is already set. Only one property must be set among these properties: UnitCalendarAvailSegments, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set UnitCalendarAvailSegments value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\UnitCalendarAvailSegments $unitCalendarAvailSegments
     * @return \rdyescapiacontent\StructType\EVRN_UnitCalendarAvailRS
     */
    public function setUnitCalendarAvailSegments(\rdyescapiacontent\StructType\UnitCalendarAvailSegments $unitCalendarAvailSegments = null)
    {
        // validation for constraint: choice(Success, UnitCalendarAvailSegments, Errors, Warnings)
        if ('' !== ($unitCalendarAvailSegmentsChoiceErrorMessage = self::validateUnitCalendarAvailSegmentsForChoiceConstraintsFromSetUnitCalendarAvailSegments($unitCalendarAvailSegments))) {
            throw new \InvalidArgumentException($unitCalendarAvailSegmentsChoiceErrorMessage, __LINE__);
        }
        if (is_null($unitCalendarAvailSegments) || (is_array($unitCalendarAvailSegments) && empty($unitCalendarAvailSegments))) {
            unset($this->UnitCalendarAvailSegments);
        } else {
            $this->UnitCalendarAvailSegments = $unitCalendarAvailSegments;
        }
        return $this;
    }
    /**
     * Get Errors value
     * @return \rdyescapiacontent\StructType\ErrorsType|null
     */
    public function getErrors()
    {
        return isset($this->Errors) ? $this->Errors : null;
    }
    /**
     * This method is responsible for validating the value passed to the setErrors method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErrors method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateErrorsForChoiceConstraintsFromSetErrors($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Success',
            'UnitCalendarAvailSegments',
            'Warnings',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Errors can\'t be set as the property %s is already set. Only one property must be set among these properties: Errors, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Errors value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\ErrorsType $errors
     * @return \rdyescapiacontent\StructType\EVRN_UnitCalendarAvailRS
     */
    public function setErrors(\rdyescapiacontent\StructType\ErrorsType $errors = null)
    {
        // validation for constraint: choice(Success, UnitCalendarAvailSegments, Errors, Warnings)
        if ('' !== ($errorsChoiceErrorMessage = self::validateErrorsForChoiceConstraintsFromSetErrors($errors))) {
            throw new \InvalidArgumentException($errorsChoiceErrorMessage, __LINE__);
        }
        if (is_null($errors) || (is_array($errors) && empty($errors))) {
            unset($this->Errors);
        } else {
            $this->Errors = $errors;
        }
        return $this;
    }
    /**
     * Get Warnings value
     * @return \rdyescapiacontent\StructType\WarningsType|null
     */
    public function getWarnings()
    {
        return isset($this->Warnings) ? $this->Warnings : null;
    }
    /**
     * This method is responsible for validating the value passed to the setWarnings method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWarnings method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateWarningsForChoiceConstraintsFromSetWarnings($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Success',
            'UnitCalendarAvailSegments',
            'Errors',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Warnings can\'t be set as the property %s is already set. Only one property must be set among these properties: Warnings, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Warnings value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\WarningsType $warnings
     * @return \rdyescapiacontent\StructType\EVRN_UnitCalendarAvailRS
     */
    public function setWarnings(\rdyescapiacontent\StructType\WarningsType $warnings = null)
    {
        // validation for constraint: choice(Success, UnitCalendarAvailSegments, Errors, Warnings)
        if ('' !== ($warningsChoiceErrorMessage = self::validateWarningsForChoiceConstraintsFromSetWarnings($warnings))) {
            throw new \InvalidArgumentException($warningsChoiceErrorMessage, __LINE__);
        }
        if (is_null($warnings) || (is_array($warnings) && empty($warnings))) {
            unset($this->Warnings);
        } else {
            $this->Warnings = $warnings;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\StructType\EVRN_UnitCalendarAvailRS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
