<?php

namespace rdyescapiacontent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReadRequests StructType
 * @subpackage Structs
 */
class ReadRequests extends AbstractStructBase
{
    /**
     * The GlobalReservationReadRequest
     * Meta information extracted from the WSDL
     * - choice: GlobalReservationReadRequest | ReadRequest
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\GlobalReservationReadRequest
     */
    public $GlobalReservationReadRequest;
    /**
     * The ReadRequest
     * Meta information extracted from the WSDL
     * - choice: GlobalReservationReadRequest | ReadRequest
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\ReadRequest
     */
    public $ReadRequest;
    /**
     * Constructor method for ReadRequests
     * @uses ReadRequests::setGlobalReservationReadRequest()
     * @uses ReadRequests::setReadRequest()
     * @param \rdyescapiacontent\StructType\GlobalReservationReadRequest $globalReservationReadRequest
     * @param \rdyescapiacontent\StructType\ReadRequest $readRequest
     */
    public function __construct(\rdyescapiacontent\StructType\GlobalReservationReadRequest $globalReservationReadRequest = null, \rdyescapiacontent\StructType\ReadRequest $readRequest = null)
    {
        $this
            ->setGlobalReservationReadRequest($globalReservationReadRequest)
            ->setReadRequest($readRequest);
    }
    /**
     * Get GlobalReservationReadRequest value
     * @return \rdyescapiacontent\StructType\GlobalReservationReadRequest|null
     */
    public function getGlobalReservationReadRequest()
    {
        return isset($this->GlobalReservationReadRequest) ? $this->GlobalReservationReadRequest : null;
    }
    /**
     * This method is responsible for validating the value passed to the setGlobalReservationReadRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGlobalReservationReadRequest method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateGlobalReservationReadRequestForChoiceConstraintsFromSetGlobalReservationReadRequest($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'ReadRequest',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property GlobalReservationReadRequest can\'t be set as the property %s is already set. Only one property must be set among these properties: GlobalReservationReadRequest, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set GlobalReservationReadRequest value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\GlobalReservationReadRequest $globalReservationReadRequest
     * @return \rdyescapiacontent\StructType\ReadRequests
     */
    public function setGlobalReservationReadRequest(\rdyescapiacontent\StructType\GlobalReservationReadRequest $globalReservationReadRequest = null)
    {
        // validation for constraint: choice(GlobalReservationReadRequest, ReadRequest)
        if ('' !== ($globalReservationReadRequestChoiceErrorMessage = self::validateGlobalReservationReadRequestForChoiceConstraintsFromSetGlobalReservationReadRequest($globalReservationReadRequest))) {
            throw new \InvalidArgumentException($globalReservationReadRequestChoiceErrorMessage, __LINE__);
        }
        if (is_null($globalReservationReadRequest) || (is_array($globalReservationReadRequest) && empty($globalReservationReadRequest))) {
            unset($this->GlobalReservationReadRequest);
        } else {
            $this->GlobalReservationReadRequest = $globalReservationReadRequest;
        }
        return $this;
    }
    /**
     * Get ReadRequest value
     * @return \rdyescapiacontent\StructType\ReadRequest|null
     */
    public function getReadRequest()
    {
        return isset($this->ReadRequest) ? $this->ReadRequest : null;
    }
    /**
     * This method is responsible for validating the value passed to the setReadRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReadRequest method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateReadRequestForChoiceConstraintsFromSetReadRequest($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'GlobalReservationReadRequest',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property ReadRequest can\'t be set as the property %s is already set. Only one property must be set among these properties: ReadRequest, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set ReadRequest value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\ReadRequest $readRequest
     * @return \rdyescapiacontent\StructType\ReadRequests
     */
    public function setReadRequest(\rdyescapiacontent\StructType\ReadRequest $readRequest = null)
    {
        // validation for constraint: choice(GlobalReservationReadRequest, ReadRequest)
        if ('' !== ($readRequestChoiceErrorMessage = self::validateReadRequestForChoiceConstraintsFromSetReadRequest($readRequest))) {
            throw new \InvalidArgumentException($readRequestChoiceErrorMessage, __LINE__);
        }
        if (is_null($readRequest) || (is_array($readRequest) && empty($readRequest))) {
            unset($this->ReadRequest);
        } else {
            $this->ReadRequest = $readRequest;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\StructType\ReadRequests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
