<?php

namespace rdyescapiacontent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnitReviewsType StructType
 * @subpackage Structs
 */
class UnitReviewsType extends AbstractStructBase
{
    /**
     * The UnitReview
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\UnitReviewType[]
     */
    public $UnitReview;
    /**
     * The PropertyManagerReview
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\PropertyManagerReviewType
     */
    public $PropertyManagerReview;
    /**
     * Constructor method for UnitReviewsType
     * @uses UnitReviewsType::setUnitReview()
     * @uses UnitReviewsType::setPropertyManagerReview()
     * @param \rdyescapiacontent\StructType\UnitReviewType[] $unitReview
     * @param \rdyescapiacontent\StructType\PropertyManagerReviewType $propertyManagerReview
     */
    public function __construct(array $unitReview = array(), \rdyescapiacontent\StructType\PropertyManagerReviewType $propertyManagerReview = null)
    {
        $this
            ->setUnitReview($unitReview)
            ->setPropertyManagerReview($propertyManagerReview);
    }
    /**
     * Get UnitReview value
     * @return \rdyescapiacontent\StructType\UnitReviewType[]|null
     */
    public function getUnitReview()
    {
        return $this->UnitReview;
    }
    /**
     * This method is responsible for validating the values passed to the setUnitReview method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUnitReview method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUnitReviewForArrayConstraintsFromSetUnitReview(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $unitReviewsTypeUnitReviewItem) {
            // validation for constraint: itemType
            if (!$unitReviewsTypeUnitReviewItem instanceof \rdyescapiacontent\StructType\UnitReviewType) {
                $invalidValues[] = is_object($unitReviewsTypeUnitReviewItem) ? get_class($unitReviewsTypeUnitReviewItem) : sprintf('%s(%s)', gettype($unitReviewsTypeUnitReviewItem), var_export($unitReviewsTypeUnitReviewItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UnitReview property can only contain items of type \rdyescapiacontent\StructType\UnitReviewType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UnitReview value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\UnitReviewType[] $unitReview
     * @return \rdyescapiacontent\StructType\UnitReviewsType
     */
    public function setUnitReview(array $unitReview = array())
    {
        // validation for constraint: array
        if ('' !== ($unitReviewArrayErrorMessage = self::validateUnitReviewForArrayConstraintsFromSetUnitReview($unitReview))) {
            throw new \InvalidArgumentException($unitReviewArrayErrorMessage, __LINE__);
        }
        $this->UnitReview = $unitReview;
        return $this;
    }
    /**
     * Add item to UnitReview value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\UnitReviewType $item
     * @return \rdyescapiacontent\StructType\UnitReviewsType
     */
    public function addToUnitReview(\rdyescapiacontent\StructType\UnitReviewType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\UnitReviewType) {
            throw new \InvalidArgumentException(sprintf('The UnitReview property can only contain items of type \rdyescapiacontent\StructType\UnitReviewType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UnitReview[] = $item;
        return $this;
    }
    /**
     * Get PropertyManagerReview value
     * @return \rdyescapiacontent\StructType\PropertyManagerReviewType|null
     */
    public function getPropertyManagerReview()
    {
        return $this->PropertyManagerReview;
    }
    /**
     * Set PropertyManagerReview value
     * @param \rdyescapiacontent\StructType\PropertyManagerReviewType $propertyManagerReview
     * @return \rdyescapiacontent\StructType\UnitReviewsType
     */
    public function setPropertyManagerReview(\rdyescapiacontent\StructType\PropertyManagerReviewType $propertyManagerReview = null)
    {
        $this->PropertyManagerReview = $propertyManagerReview;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\StructType\UnitReviewsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
